
(****************************************************************)
(*                                                              *)
(*                    Delphi 5, 4 Path                          *)
(*             Copyright (c) 2001 by Adam Boduch                *)
(*    Service for programmers: http://programowanie.of.pl       *)
(*               E - mail:  boduch@poland.com                   *)
(*                                                              *)
(****************************************************************)
     
program Path;

uses
  Windows;

//-------------------------------------------------------
//   Lata ta umozliwia stosowanie polskich liter w Delphi 4 lub 5 :)
//   Na poczatek pobiera z nazy pliku wersje Delphi. Jezeli plik nazwany
//   jest Path 5.0 to znaczy, ze masz wersje 5.0
//-------------------------------------------------------

const Value  : PChar = '1'; // wartosc, ktora zostanie umieszczona w kluczu

var KeyHandle : HKEY; // uchwyt dla rejestru
    Ver : String; // wersja Delphi

begin
{   pobierz nazwe Delphi z nazwy tej laty. Do zmiennej Ver przypisz odpowiednia wartosc }
  if Pos('5.0', ParamStr(0)) > 0 then Ver := '5.0' else
    if Pos('4.0', ParamStr(0)) > 0 then Ver := '4.0';

{ nastepnie otworz rejestr i dodaj do niego nowa wartoc typu String - umozliwia to stosowanie polskich liter }

  RegOpenKeyEx(HKEY_CURRENT_USER, PChar('SOFTWARE\Borland\Delphi\' + Ver + '\Editor\Options'), 0,
  KEY_ALL_ACCESS, KeyHandle);
  RegSetValueEx(KeyHandle, 'NoCtrlAltKeys', 0, REG_SZ, Value, SizeOf(Value));
end.
