
{
   Copyright (c) 2001 - Adam Boduch
}

unit MainFrm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TMainForm = class(TForm)
    btnOpen: TButton;
    edtTitle: TEdit;
    edtArtist: TEdit;
    edtAlbum: TEdit;
    edtYear: TEdit;
    edtComment: TEdit;
    edtGenre: TEdit;
    OpenDialog: TOpenDialog;
    procedure btnOpenClick(Sender: TObject);
  end;

var
  MainForm: TMainForm;

implementation

{$R *.DFM}

{
 Oto rekord, ktry zawiera elementy, ktre bdziemy odczytywa z pliku mp3.
 Kada zmienna rekordu ma przeznaczon prawidow ilo znakw na dany element.
}

type
  TTag = packed record
    ID: String[3]; // czy Tag istnieje?
    Title : String[30]; // tytu
    Artist : String[30]; // wykonawca
    Album : String[30]; // album
    Year : String[4]; // rok wydania
    Comment : String[30]; // komentarz
    Genre : Byte; // typ - np. POP, Techno, Jazz itp.
  end;


const
{  oto tablica zawierajca typy utworw }
  Genre : array[0..79] of ShortString = (
  ('Blues'), ('Classic Rock'), ('Country'), ('Dance'), ('Disco'),
  ('Funk'), ('Grunge'), ('Hip-Hop'), ('Jazz'), ('Metal'), ('New Age'),
  ('Oldies'), ('Other'), ('Pop'), ('R&B'), ('Rap'), ('Reggae'),
  ('Rock'), ('Techno'), ('Industrial'), ('Alternative'), ('Ska'),
  ('Death Metal'), ('Pranks'), ('Soundtrack'), ('Euro-Techno'), ('Ambient'),
  ('Trip-Hop'), ('Vocal'), ('Jazz+Funk'), ('Fusion'), ('Trance'),
  ('Classical'), ('Instrumental'), ('Acid' ), ('House'), ('Game'),
  ('Sound Clip'), ('Gospel'), ('Noise'), ('AlternRock'), ('Bass'),
  ('Soul'), ('Punk'), ('Space'), ('Meditative'), ('Instrumental Pop'),
  ('Instrumental Rock'), ('Ethnic'), ('Gothic'), ('Darkwave'),
  ('Techno-Industrial'), ('Electronic'), ('Pop-Folk'), ('Eurodance'),
  ('Dream'), ('Southern Rock'), ('Comedy'), ('Cult'), ('Gangsta'),
  ('Top 40'), ('Christian Rap'), ('Pop/Funk'), ('Jungle'), ('Native American'),
  ('Cabaret'), ('New Wave'), ('Psychadelic'), ('Rave'), ('Showtunes'),
  ('Trailer'), ('Lo-Fi'), ('Tribal'), ('Acid Punk'), ('Acid Jazz'),
  ('Polka'), ('Retro'), ('Musical'), ('Rock & Roll'), ('Hard Rock')
  );



procedure TMainForm.btnOpenClick(Sender: TObject);
var
  mpFile : File;
  Buffer : array[1..128] of char; // tutaj przechowywane bd wszystkie dane
  Tag : TTag;  // zmienna wskazujca na rekord
begin
  if OpenDialog.Execute then
  begin
    AssignFile(mpFile, OpenDialog.FileName);
    Reset(mpFile, 1);  // otwrz plik
    Seek(mpFile, FileSize(mpFile) -128); // ustaw na ostatnich 128 bajtach
    BlockRead(mpFile, Buffer, SizeOf(Buffer)); // odczytaj bajty i przypisz do zmiennej Buffer
    CloseFile(mpFile);  // mona ju zamkn plik
    with Tag do
    begin
 { tutaj nastpuje rozdzielenie tekstu i przypisanie odpowiednim elementom rekordu }
      ID := Copy(Buffer, 1, 3);
      Title := Copy(Buffer, 4, 30);
      Artist := Copy(Buffer, 34, 30);
      Album := Copy(Buffer, 64, 30);
      Year := Copy(Buffer, 94, 4);
      Comment := Copy(Buffer, 98, 30);
      Genre := Ord(Buffer[128]);
    end;
    if TAG.ID = 'TAG' then // czy wougle tak zosta odczytany?
    begin
      edtTitle.Text := Tag.Title;
      edtArtist.Text := Tag.Artist;
      edtAlbum.Text := Tag.Album;
      edtYear.Text := Tag.Year;
      edtComment.Text := Tag.Comment;
      edtGenre.Text := Genre[Tag.Genre];
    end else Application.MessageBox('Tag w tym pliku mp3 NIE ISTNIEJE!', 'Nie istnieje...', MB_OK + MB_ICONINFORMATION);
  end;
end;

end.
