
(**********************************************************)
(*            Borland Delphi Screen Saver                 *)
(*              The Matrix Screen Saver                   *)
(*          Copyright  2001 by Adam Boduch               *)
(*             Build: 23 lutego 2001  21:35               *)
(*               SERVICE FOR PROGRAMMERS:                 *)
(*             HTTP://WWW.PROGRAMOWANIE.OF.PL             *)
(*        e - Mail:   boduch@poland.com                   *)
(**********************************************************)
//
//  Przykadowy wygaszacz ekranu do kursu:
//    " Delphi dla poczatkujacych "
//  http://www.programowanie.of.pl

unit MainFrmU;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs;

type
  TMainFrm = class(TForm)
    procedure FormActivate(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure FormCreate(Sender: TObject);
  end;

var
  MainFrm: TMainFrm;
  Done : Boolean;// animacja jest w ruchu?

implementation

{$R *.DFM}

procedure TMainFrm.FormActivate(Sender: TObject);
var
  X, X1, I, Count : Integer;
  Chars : Char; // zmienna oznaczajca znak ( pojedynczy )
begin
  Count := 0; // wyzeruj licznik
  while not (Done) do // Jezeli animacja jest uruchomiona...
  begin
    Canvas.Brush.Color := clBlack; // ustaw kolor ta
    Randomize; // wylosuj
    X := Random(Screen.DesktopWidth); // losuj pozycje
    X1 := Random(Screen.DesktopWidth);
    Canvas.Font.Color := RGB(25, 255, 0); // ustaw kolor czcionki
    Canvas.Font.Size := 12; // rozmiar czcionki

    Inc(Count); // podnie o jeden
    if Count = 40 then // Jezeli licznik rowna sie cyfrze 30...
    begin
      Repaint; //... odswiez ekran
      Count := 0; // wyzeruj licznik
    end;

{  Wykonuj petle. Zacznij od zera i kontynuuj do wylosowanego punktu }

    For I := 0 to Screen.DesktopHeight do
    BEGIN
      Application.ProcessMessages;
      Sleep(2);
      Chars := Chr(Random(255)); // losuj znak
      Canvas.TextOut(X, I, Chars); // spuszczaj :) znak
      Canvas.TextOut(X1, I - 70, Chars);
      if (Done) then // Jezeli Done = True to przerwij...
        Break;
    END;
  end;
end;

procedure TMainFrm.FormKeyPress(Sender: TObject; var Key: Char);
begin
  Done := True; // przerwij
  Close; // zamknij program
end;

procedure TMainFrm.FormCreate(Sender: TObject);
var
  H : THandle;
begin
  H := CreateFileMapping(THANDLE($FFFFFFFF),nil,
  PAGE_READONLY,0,32,'Screen');

{ Jezeli aplikacja jest uruchomiona ( ALREADY_EXISTS ) to zamknij
  druga }
  if GetLastError=ERROR_ALREADY_EXISTS then
  begin
    Application.Terminate;
    CloseHandle(H);
  end;
  
  Color := clBlack; // kolor tla
  ShowCursor(FALSE); // ukryj kursor
end;

end.
