
(**********************************************************)
(*         Resource Test programme for Delphi 5           *)
(*            Copyright  2001 by Adam Boduch             *)
(*                All rights reserved                     *)
(*               Build:  17 luty 2001 r.                  *)
(*              E-mail:    boduch@poland.com              *)
(*       SERVICE FOR PROGRAMMERS:                         *)
(*          HTTP://WWW.PROGRAMOWANIE.OF.PL                *)
(**********************************************************)
//
//  Ten program jest przykladem to artykulu "Przykladowe
//  animacje", ktory znajduje sie na stronie: www.programowanie.of.pl
//  Jest to program freeware, czyli mozesz go umieszczac gdzie
//  zechcesz, ale z zachowaniem praw autorskich.
//
//  Program ma za zadanie wyswietlac bitmapy znajdujace sie
//  w zasobach tworzac przy tym efekt animacji...
//  Dodatkowo przy tym odtwarzany jest dzwiek i ladowany tekst
//  ( wszystko z zasobow ).

unit MainForm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, MMSystem {modul umozliwiajace\y odtwarzanie muzyki };

{ Oto zasoby zawierajace bitmapki oraz muzyke }
{$R FILES.RES}
{$R WAVE.RES}

type
  TMainFrm = class(TForm)
    Button1: TButton;
    Panel1: TPanel;
    Image1: TImage;
    procedure Button1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  MainFrm: TMainFrm;
  Done : Boolean; // zmienna informujaca, czy animacja jest w ruchu

const
  BName = 'ID_BITMAP'; // pierwszy czlon nazwy bitmapek
  STRING1 = 101; // wartosc liczbowa pierwszego Stringa umieszczonego w zasobach
  STRING2 = 102; // wartosc liczbowa drugiego Stringa umieszczonego w zasobach

implementation

{$R *.DFM}

procedure TMainFrm.Button1Click(Sender: TObject);
var
  i : Integer;
  Buff: array [0..MAX_PATH] of Char; // ta zmienna musi miec taka postac...
begin
  while not (Done) do  // Jezeli zmienna Done = False tzn., ze animacja jest uruchomiona
  begin
{
  Petla ta powoduje ladowanie po kolei obrazkow z zasobow. Dzieki temu
  odnosi sie wrazenie animacji. Stala "BNAME" okresla slowo "ID_BITMAP" do
  ktorego dodawane sa cyfry oznaczajace numery bitmapy.
}
  for i:=1 to 4 do
  begin
    Application.ProcessMessages;  // daj odetchnac systemowi, aby przetworzyl komunikaty
      Sleep(100); // czekaj 100 milisekund ( 1000 milisekund = 1 sek. )
    Image1.Picture.Bitmap.LoadFromResourceName( // zaladuja bitmape z zasobow
      hInstance, BName + IntToStr(i));
  end;

{
   Ponizsze polecenia kolejno odgrywaja oraz laduja tekst z zasobow.
   Pierwsza funkcja "PlaySound" powoduje zaladowanie z zasobow muzyki i
   odtworzenie jej.
   Druga funkcja laduje z zasobow tekst i przypisuje go do zmiennej
   "Buff". Nastepnie tekst ten wyswietlony jest na pasku formy.

   "STRING1" to stala oznaczajaca cyfre 101. Pod to cyfra kryje sie
   tekst, ktory ma byc zladowany z zasobow.
}
    PlaySound('ID_WAVE', hInstance, SND_ASYNC or SND_RESOURCE);
    LoadString(hInstance, STRING1, Buff, SizeOf(Buff));
    Caption := Buff;

  Sleep(50);  // czkeja 50 milisekund

{
  Teraz ta petla odtwarza animacje od tylu tzn., idea jest taka
  sama jak w poprzedniej petli tyle ze bitmapy ladowane sa od
  tylu.
}
  for i:=4 downto 1 do
  begin
    Application.ProcessMessages;
      Sleep(100);   // czekaj 100 milisekund
    Image1.Picture.Bitmap.LoadFromResourceName( // zaladuj bitmapki
      hInstance, BName + IntToStr(i));
  end;

{ To samo co wyzej tyle, ze ladowany jest inny tekst....        }
   PlaySound('ID_WAVE', hInstance, SND_ASYNC or SND_RESOURCE);
   LoadString(hInstance, STRING2, Buff, SizeOf(Buff));
   Caption := Buff;

  end;
end;

procedure TMainFrm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Done := True; // zakoncz animacje i zamknij program....
end;

end.
