{
  Copyright  2001 - Adam Boduch
}

unit MainFrm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TMainForm = class(TForm)
    btnCreate: TButton;
    btnAbout: TButton;
    procedure btnCreateClick(Sender: TObject);
    procedure btnAboutClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  MainForm: TMainForm;

implementation

{$R *.DFM}

uses Samo;

type
  TF1 = class(TSamochod) { dziedziczenie z klasy TSamochod }
  private
    procedure About; override; { przedefiniowanie metody }
  end;

procedure TMainForm.btnCreateClick(Sender: TObject);
var
  Samochod : TSamochod;  // wskazanie na now klas
begin
  Samochod := TSamochod.Create(110); // stwrz klas
  ShowMessage(IntToStr( // wywietl rezultat jej wykonania
    Samochod.JakaPredkosc));
  Samochod.Free; // zwolnij
end;

procedure TMainForm.btnAboutClick(Sender: TObject);
var
  F1 : TF1;
begin
  F1 := TF1.Create(110);
  F1.About; { <-- teraz procedura jest "widoczna" }
  F1.Free;
end;

{ TF1 }

procedure TF1.About;
begin
  inherited; // wykonanie procedury About z klasy TSamochod
  ShowMessage('Tak naprawd to ja jestem procedura z innej klasy');
end;

end.
