
{
   Copyright (c) 2001 - Adam Boduch
}

unit MainFrm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, Menus, ExtDlgs, ChildFrm;

type
  TMainForm = class(TForm)
    StatusBar: TStatusBar;
    MainMenu: TMainMenu;
    FileMenu: TMenuItem;
    EditMenu: TMenuItem;
    FileNew: TMenuItem;
    FileOpen: TMenuItem;
    FileSave: TMenuItem;
    N1: TMenuItem;
    FilePrint: TMenuItem;
    FilePrintSetup: TMenuItem;
    N2: TMenuItem;
    FileExit: TMenuItem;
    EditCut: TMenuItem;
    EditCopy: TMenuItem;
    EditPaste: TMenuItem;
    HelpMenu: TMenuItem;
    About: TMenuItem;
    HelpContact: TMenuItem;
    HelpNew: TMenuItem;
    HelpBug: TMenuItem;
    OpenPictureDialog: TOpenPictureDialog;
    SavePictureDialog: TSavePictureDialog;
    Win: TMenuItem;
    WinTile: TMenuItem;
    WinCascade: TMenuItem;
    WinArrange: TMenuItem;
    procedure FileOpenClick(Sender: TObject);
    procedure FileSaveClick(Sender: TObject);
    procedure WinTileClick(Sender: TObject);
    procedure WinCascadeClick(Sender: TObject);
    procedure WinArrangeClick(Sender: TObject);
  private

  public

  end;

var
  MainForm: TMainForm;


implementation

{$R *.DFM}

procedure TMainForm.FileOpenClick(Sender: TObject);
begin
  if OpenPictureDialog.Execute then // jeeli okienko zostanie wywietlone...
  begin
    ChildForm := TChildForm.Create(Self);  //...stwrz okno Child
    { zaaduj obrazek }
    ChildForm.Image.Picture.LoadFromFile(OpenPictureDialog.FileName);
    with ChildForm do
    begin
    { dopasuj rozmiary obszaru roboczego do rozmiarw obrazka }
      ClientWidth := Image.Picture.Width;
      ClientHeight := Image.Picture.Height;
    end;
    ChildForm.Caption := OpenPictureDialog.FileName; // do tytuu okna przypisz wybrany plik
    ChildForm.Show; // wywietl okno
  end;
end;

procedure TMainForm.FileSaveClick(Sender: TObject);
begin
  if SavePictureDialog.Execute then // Jeeli okno zostanie wywietlone...
  { zapisz zawarto komponentu  Image do pliku }
    (ActiveMDIChild as TChildForm).Image.Picture.SaveToFile(SavePictureDialog.FileName);
end;

procedure TMainForm.WinTileClick(Sender: TObject);
begin
// ssiadujco
  Tile;
end;

procedure TMainForm.WinCascadeClick(Sender: TObject);
begin
// kaskada
  Cascade;
end;

procedure TMainForm.WinArrangeClick(Sender: TObject);
begin
// uporzdkuj
  ArrangeIcons;
end;

end.
